#include "soapH.h"
#include "calc.nsmap"

#include <stdlib.h>
#include <unistd.h>

#ifdef MOD_GSOAP
#include "apache_gsoap.h"
#else
#include "CGIplus_gsoap.h"
#endif

#ifdef MOD_GSOAP

IMPLEMENT_GSOAP_SERVER()

#else

int main(int argc, char **argv)
{
  	struct soap soap;

    	CGIplus_InitVMS (argc, argv);
  	soap_init1 (&soap, SOAP_IO_BUFFER);

    	while (CGIplus_Accept() >= 0)
	{
    	   soap_serve(&soap);
	   soap_end(&soap);
	}


  return 0;
}

#endif /* MOD_GSOAP */

int ns__add(struct soap *soap, double a, double b, double *result)
{ *result = a + b;
  return SOAP_OK;
}

int ns__sub(struct soap *soap, double a, double b, double *result)
{ *result = a - b;
  return SOAP_OK;
}

int ns__mul(struct soap *soap, double a, double b, double *result)
{ *result = a * b;
  return SOAP_OK;
}

int ns__div(struct soap *soap, double a, double b, double *result)
{ if (b)
    *result = a / b;
  else
  { char *s = (char*)soap_malloc(soap, 1024);
    sprintf(s, "<error xmlns=\"http://tempuri.org/\">Can't divide %f by %f</error>", a, b);
    return soap_sender_fault(soap, "Division by zero", s);
  }
  return SOAP_OK;
}

int ns__pow(struct soap *soap, double a, double b, double *result)
{ *result = pow(a, b);
  if (soap_errno == EDOM)	/* soap_errno is like errno, but compatible with Win32 */
  { char *s = (char*)soap_malloc(soap, 1024);
    sprintf(s, "Can't take the power of %f to %f", a, b);
    sprintf(s, "<error xmlns=\"http://tempuri.org/\">Can't take power of %f to %f</error>", a, b);
    return soap_sender_fault(soap, "Power function domain error", s);
  }
  return SOAP_OK;
}
